#pragma semicolon 1

#include <sourcemod>
#include <sdktools>
#include <vip_core>
#include <cstrike>

public Plugin:myinfo =
{
	name = "[VIP] Kick",
	author = "R1KO (skype: vova.andrienko1)",
	version = "1.0.1"
};

#define VIP_KICK				"Kick"

public VIP_OnVIPLoaded()
{
	VIP_RegisterFeature(VIP_KICK, BOOL, SELECTABLE, OnSelectItem);
}

new Handle:g_hReasonsMenu,
	g_iCvar_AdminImmunityMode,
	bool:g_bCvar_VIPImmunityMode;

public OnPluginStart()
{
	LoadTranslations("common.phrases");
	LoadTranslations("plugin.basecommands");

	g_hReasonsMenu = CreateMenu(Handler_ReasonsMenu, MenuAction_Select|MenuAction_Cancel);
	SetMenuExitBackButton(g_hReasonsMenu, true);
	SetMenuTitle(g_hReasonsMenu, "Причина:\n \n");
}

public OnMapStart()
{
	RemoveAllMenuItems(g_hReasonsMenu);
	
	decl String:sBuffer[256], Handle:hKeyValues;

	hKeyValues = CreateKeyValues("Kick");
	BuildPath(Path_SM, sBuffer, 256, "data/vip/modules/kick.ini");

	if (FileToKeyValues(hKeyValues, sBuffer) == false)
	{
		SetFailState("Не удалось открыть файл \"%s\"", sBuffer);
	}
	
	KvRewind(hKeyValues);
	
	g_iCvar_AdminImmunityMode = KvGetNum(hKeyValues, "vip_kick_admin_immunity");
	g_bCvar_VIPImmunityMode = bool:KvGetNum(hKeyValues, "vip_kick_vip_immunity");
	
	if (KvJumpToKey(hKeyValues, "Reasons") && KvGotoFirstSubKey(hKeyValues, false))
	{
		decl String:sReason[64];
		do
		{
			KvGetSectionName(hKeyValues, sReason, sizeof(sReason));
			KvGetString(hKeyValues, NULL_STRING, sBuffer, sizeof(sBuffer));
			AddMenuItem(g_hReasonsMenu, sBuffer, sReason);
		}
		while (KvGotoNextKey(hKeyValues, false));
	}
	
	CloseHandle(hKeyValues);
}

public bool:OnSelectItem(iClient, const String:sFeatureName[])
{
	DisplayMenu(CreatePlayersMenu(iClient), iClient, MENU_TIME_FOREVER);
	return false;
}

Handle:CreatePlayersMenu(iClient)
{
	decl String:sUserID[16], String:sName[64], Handle:hMenu, i, AdminId:AID;
	hMenu = CreateMenu(PlayersMenu_Handler);
	SetMenuExitBackButton(hMenu, true);
	SetMenuTitle(hMenu, "%T:\n \n", "Kick player", iClient);
	
	sUserID[0] = 0;
	for(i = 1; i <= MaxClients; ++i)
	{
		if(IsClientInGame(i))
		{
			if(g_bCvar_VIPImmunityMode && VIP_IsClientVIP(i))
			{
				continue;
			}
			
			AID = GetUserAdmin(i);
			if(g_iCvar_AdminImmunityMode == 0 && AID != INVALID_ADMIN_ID)
			{
				continue;
			}

			if(g_iCvar_AdminImmunityMode > 0 && GetAdminImmunityLevel(AID) >= g_iCvar_AdminImmunityMode)
			{
				continue;
			}
			
			GetClientName(i, sName, sizeof(sName));
			IntToString(GetClientUserId(i), sUserID, sizeof(sUserID));
			AddMenuItem(hMenu, sUserID, sName);
		}
	}

	if(sUserID[0] == 0)
	{
		FormatEx(sName, sizeof(sName), "%T", "No matching clients", iClient);
		AddMenuItem(hMenu, "", sName, ITEMDRAW_DISABLED);
	}

	return hMenu;
}

public PlayersMenu_Handler(Handle:hMenu, MenuAction:action, iClient, Item)
{
	switch(action)
	{
		case MenuAction_End: CloseHandle(hMenu);
		case MenuAction_Cancel:
		{
			if(Item == MenuCancel_ExitBack)
			{
				VIP_SendClientVIPMenu(iClient);
			}
		}
		case MenuAction_Select:
		{
			decl String:sUserID[16], UserID;
			GetMenuItem(hMenu, Item, sUserID, sizeof(sUserID));
			UserID = StringToInt(sUserID);
			if(GetClientOfUserId(UserID) > 0)
			{
				SetTrieValue(VIP_GetVIPClientTrie(iClient), "KickTarget", UserID);
				DisplayMenu(g_hReasonsMenu, iClient, MENU_TIME_FOREVER);
			}
			else
			{
				PrintToChat(iClient, "[SM] %t", "Player no longer available");
			}
		}
	}
}

public Handler_ReasonsMenu(Handle:hMenu, MenuAction:action, iClient, Item)
{
	switch(action)
	{
		case MenuAction_Cancel:
		{
			if(Item == MenuCancel_ExitBack)
			{
				DisplayMenu(CreatePlayersMenu(iClient), iClient, MENU_TIME_FOREVER);
			}
		}
		case MenuAction_Select:
		{
			decl String:sReason[128], iTarget;
			GetMenuItem(hMenu, Item, sReason, sizeof(sReason));
			if(GetTrieValue(VIP_GetVIPClientTrie(iClient), "KickTarget", iTarget))
			{
				iTarget = GetClientOfUserId(iTarget);
				if(iTarget && IsClientInGame(iTarget))
				{
					decl String:sName[MAX_NAME_LENGTH];
					GetClientName(iTarget, sName, sizeof(sName));
					VIP_PrintToChatAll("\x01VIP-игрок \x04%N \x01кикнул игрока \x04%s \x01(Причина: \x04%s\x01)", iClient, sName, sReason);
					VIP_PrintToChatClient(iClient, "\x01%t", "Kicked target reason", "_s", sName, sReason);
					LogAction(iClient, iTarget, "VIP-игрок \"%L\" кикнул игрока \"%L\" (Причина: %s)", iClient, iTarget, sReason);
					KickClient(iTarget, sReason);
				}
				else
				{
					PrintToChat(iTarget, "[SM] %t", "Player no longer available");
				}
			}
		}
	}
}
